/*
  Author:  Jonathan Bondzie, Dr. Chuck Yeung
           Lennard Gas Simulation Source

	   Copyright (C) 1999  Penn State University

	   This program is free software; you can redistribute it and/or
	   modify it under the terms of the GNU General Public License
	   as published by the Free Software Foundation;
	   
	   This program is distributed in the hope that it will be useful,
	   but WITHOUT ANY WARRANTY; without even the implied warranty of
	   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	   GNU General Public License for more details.
	   
	   You should have received a copy of the GNU General Public License
	   along with this program; if not, write to the Free Software
	   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
	   02111-1307, USA.

	   email jab341@psu.edu
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>

/* all the include files for the motif widgets */

#include <Xm/Xm.h>
#include <Xm/Label.h>           /* Xmlabel */
#include <Xm/PushB.h>           /* XmPushButton */
#include <Xm/PanedW.h>          /* XmPanedWindow */
#include <Xm/MainW.h>           /* XmMainWindow */
#include <Xm/RowColumn.h>       /* XmMenuBar and XmPulldownMenu */
#include <Xm/CascadeB.h>        /* XmCascadeButton */
#include <Xm/Separator.h>       /* XmSeparator */
#include <Xm/Text.h>            /* XmText */
#include <Xm/DrawingA.h>	/* XmDrawingArea */
#include <Xm/SelectioB.h>	/* for dialogues */
#include <Xm/MessageB.h>	/* for dialogues */
#include <Xm/Form.h>
#include <Xm/ToggleBG.h>

/* structure definition used in continueCB and doubleCB */

typedef struct { float* floatptr;
                 Widget* widgptr; } FptrWptr;

/* environmental variable used in continueCB */

#define CONTINUE_TIME   500

extern	Widget	CreatePulldownMenu(Widget, char*);
extern	Widget	CreateHelpMenu(Widget, char*);
extern	Widget	CreatePushbutton(Widget, char*, XtCallbackProc, XtPointer);
extern	Widget  CreateDrawingArea(Widget, char*, XtCallbackProc, XtPointer); 
extern	void	exitCB(Widget, XtPointer, XtPointer);
extern	void	loop(Widget, XtPointer, XtPointer);
extern	void 	genericCB(Widget, XtPointer, XtPointer );
extern	void 	promptCB(Widget, XtPointer, XtPointer );
extern	void 	cancel_prompt_CB(Widget, XtPointer, XtPointer );
extern  void    doubleCB(Widget, XtPointer, XtPointer);
extern  void    continueCB(Widget, XtPointer, XtPointer);
extern  void    scale10KE(Widget, XtPointer, XtPointer);
extern  void    scaleDKE(Widget, XtPointer, XtPointer);

extern  Widget  createTableFloat(Widget, char*, char*, float);
extern void drawCB(Widget widget, XtPointer client_data, XtPointer call_data);

extern char* pasteFloatToWidget( float, int,  Widget, XmTextPosition);

extern XmString makeXmStringFromFloat(float fnumber);

extern Widget CreatePromptDialogWithFloat( Widget, 
        char*, char*, float*, XtCallbackProc, XtPointer);

extern void manageCB(Widget, XtPointer, XtPointer);

/***** updates float from a writeable text widget *****/

extern void newfloatCB(Widget widget,  XtPointer client_data,
                 XtPointer call_data);

